strength = 1 -- Debris Blow away Power
maxMass = 100 -- Debris Weight Affected by Blast
maxDist = 20 -- Debris Distance Affected by Blast
plasma = 1 -- Point light at plasma Hitpoint
power = .01 -- Combined Power Output with LMB+RMB

function init()
	RegisterTool("incinerator", "Incinerator", "MOD/vox/Incinerator.vox")
	SetBool("game.tool.incinerator.enabled", true)
	SetInt("game.tool.incinerator.ammo", 100)
	snd1 = LoadLoop("incinerate.ogg")
	snd2 = LoadLoop("plasma.ogg")
	snd3 = LoadSound("ignition.ogg")
	snd4 = LoadSound("extinguish.ogg")
	snd5 = LoadLoop("electricity.ogg")
end

cooldownTimer = 0

function tick(dt)
	-- Options Hide Feature
	if GetString("game.player.tool") == "incinerator" and GetPlayerVehicle() == 0 then
		if InputPressed("h") and cooldownTimer <= 0 then
			cooldownTimer = 10000
		end
		if InputPressed("o") or InputPressed("p") and cooldownTimer > 0 then
			cooldownTimer = 0
		end
	end

	-- Only active when not in a Vehicle and using the Plasma Incinerator
	if GetString("game.player.tool") == "incinerator" and GetPlayerVehicle() == 0 then
		-- Trigger for Combined Power Output
		if InputDown("lmb") and InputDown("rmb") then
			shooting7()
		end
	end

function lookpos()
  local tb = GetToolBody()
  local tbt = GetBodyTransform(tb)
  local pos = tbt.pos
  local dir = TransformToParentVec(tbt, Vec(-0.02, 0.02, -1))
  hit, dist, normal, shape = QueryRaycast(tbt.pos, dir, 16)
  if hit then
      local pos = VecAdd(tbt.pos, VecScale(dir, dist))
      return pos
    else
      return false
    end
end

function shooting7() -- Function for Combined Power Output MakeHoles
  if lookpos() then
    MakeHole(lookpos(), math.random(20, 50)*power, math.random(10, 30)*power, math.random(5, 20)*power, "silent")
  end
end

	if GetString("game.player.tool") == "incinerator" and GetBool("game.player.canusetool") then
		SetBool("hud.aimdot", false)

		-- Ignition and Extinguish sound effects for Plasma and Incinerator
		if GetString("game.player.tool") == "incinerator" and InputPressed("rmb") then
        	PlaySound(snd3, GetPlayerTransform().pos, (math.random(60, 70)*0.01))
        end
		if GetString("game.player.tool") == "incinerator" and InputReleased("rmb") then
        	PlaySound(snd4, GetPlayerTransform().pos, (math.random(30, 50)*0.01))
        end
		
		if GetString("game.player.tool") == "incinerator" and InputPressed("lmb") then
        	PlaySound(snd3, GetPlayerTransform().pos, (math.random(50, 60)*0.01))
        end
   		if GetString("game.player.tool") == "incinerator" and InputReleased("lmb") then
       	 	PlaySound(snd4, GetPlayerTransform().pos, (math.random(10, 20)*0.01)) 
       	end

		-- Plasma point light intensity toggle change by pressing "P"
		if InputPressed("p") and plasma == 3 then 
			plasma = 1	
		elseif InputPressed("p") and plasma == 1 then
			plasma = .3
		elseif InputPressed("p") and plasma == .3 then
			plasma = 0
		elseif InputPressed("p") and plasma == 0 then
			plasma = 9	
		elseif InputPressed("p") and plasma == 9 then
			plasma = 3
		end

		-- Combined Power Output toggle change by pressing "O"
		if InputPressed("o") and power == .01 then 
			power = .02	
		elseif InputPressed("o") and power == .02 then
			power = .03
		elseif InputPressed("o") and power == .03 then
			power = .01
		end

		-- Resting Tool Position
		local offset = Transform(Vec(0.3, -0.3, -.74))
		SetToolTransform(offset, 0.6)

		-- Minimum Tool Recoil
		if InputDown("rmb") or InputDown("lmb") then
			local offset = Transform(Vec(0.3, -0.3, -.71))
			SetToolTransform(offset, 0.3)
		end

		-- Maximum Tool Recoil
		if InputDown("rmb") and InputDown("lmb") then
			local offset = Transform(Vec(0.3, -0.3, -.68))
			SetToolTransform(offset, 0.3)
		end

		-- Check if Right Mouse Button is Pressed Down activating Incinerator Flames
		if InputDown("rmb") and not InputDown("lmb") then
			
			-- Get fire spawn locations in front of Player
			local t = GetCameraTransform()		
			local c = TransformToParentPoint(t, Vec(0.3, -0.3, -1))
			local d = TransformToParentPoint(t, Vec(0.3, -0.3, -2.5))
			local dd = TransformToParentPoint(t, Vec(0.7, -0.7, -2.8))
			local ddd = TransformToParentPoint(t, Vec(0.7, .1, -3.1))
			local dddd = TransformToParentPoint(t, Vec(-0.1, -0.7, -3.4))
			local ddddd = TransformToParentPoint(t, Vec(-0.1, .1, -3.7))	
			local e = TransformToParentPoint(t, Vec(0.2, -0.2, -4))
			local ee = TransformToParentPoint(t, Vec(0.7, -0.7, -4.3))
			local eee = TransformToParentPoint(t, Vec(0.7, 0.3, -4.6))
			local eeee = TransformToParentPoint(t, Vec(-0.3, -0.7, -4.9))
			local eeeee = TransformToParentPoint(t, Vec(-0.3, 0.3, -5.2))
			local f = TransformToParentPoint(t, Vec(0.2, -0.2, -5.5))
			local ff = TransformToParentPoint(t, Vec(0.8, -0.8, -5.8))
			local fff = TransformToParentPoint(t, Vec(0.8, 0.4, -6.1))
			local ffff = TransformToParentPoint(t, Vec(-0.4, -0.8, -6.4))
			local fffff = TransformToParentPoint(t, Vec(-0.4, 0.4, -6.7))	
			local g = TransformToParentPoint(t, Vec(0.1, -0.1, -7))
			local gg = TransformToParentPoint(t, Vec(0.8, -0.8, -7.3))
			local ggg = TransformToParentPoint(t, Vec(0.8, 0.6, -7.6))
			local gggg = TransformToParentPoint(t, Vec(-0.6, -0.8, -7.9))
			local ggggg = TransformToParentPoint(t, Vec(-0.6, 0.6, -8.2))
			local h = TransformToParentPoint(t, Vec(0.1, -0.1, -8.5))	
			local hh = TransformToParentPoint(t, Vec(0.9, -0.9, -8.8))
			local hhh = TransformToParentPoint(t, Vec(0.9, 0.7, -9.1))
			local hhhh = TransformToParentPoint(t, Vec(-0.7, -0.9, -9.4))	
			local hhhhh = TransformToParentPoint(t, Vec(-0.7, 0.7, -9.7))
			local i = TransformToParentPoint(t, Vec(0.1, -0.1, -10))
			local ii = TransformToParentPoint(t, Vec(0.7, -0.7, -10.5))
			local iii = TransformToParentPoint(t, Vec(0.7, 0.5, -11))	
			local iiii = TransformToParentPoint(t, Vec(-0.5, -0.7, -11.5))
			local j = TransformToParentPoint(t, Vec(-0.5, 0.5, -12))	
			local jj = TransformToParentPoint(t, Vec(0, 0, -12.5))
			local jjj = TransformToParentPoint(t, Vec(0.4, -0.4, -13))
			local jjjj = TransformToParentPoint(t, Vec(0.4, 0.4, -13.5))	
			local k = TransformToParentPoint(t, Vec(-0.4, -0.4, -14))
			local kk = TransformToParentPoint(t, Vec(-0.4, 0.4, -14.5))
			local kkk = TransformToParentPoint(t, Vec(0, 0, -15))	
			local kkkk = TransformToParentPoint(t, Vec(0.3, -0.3, -15.5))
			local kkkkk = TransformToParentPoint(t, Vec(-0.3, 0.3, -16))

			-- make tons of fire if something combustible is there
			SpawnFire(c) SpawnFire(d) SpawnFire(dd)
			SpawnFire(ddd) SpawnFire(dddd) SpawnFire(ddddd)
			SpawnFire(e) SpawnFire(ee) SpawnFire(eee)
			SpawnFire(eeee) SpawnFire(eeeee) SpawnFire(f)
			SpawnFire(ff) SpawnFire(fff) SpawnFire(ffff)
			SpawnFire(fffff) SpawnFire(g) SpawnFire(gg)
			SpawnFire(ggg) SpawnFire(gggg) SpawnFire(ggggg)
			SpawnFire(h) SpawnFire(hh) SpawnFire(hhh)
			SpawnFire(hhhh) SpawnFire(hhhhh) SpawnFire(i)
			SpawnFire(ii) SpawnFire(iii) SpawnFire(iiii)
			SpawnFire(j) SpawnFire(jj) SpawnFire(jjj)
			SpawnFire(jjjj) SpawnFire(k) SpawnFire(kk)
			SpawnFire(kkk) SpawnFire(kkkk) SpawnFire(kkkkk)	
			PointLight(c, 1, 0.7, 0.3, 0.40)
			PointLight(d, 1, 0.7, 0.3, 0.40)
			PointLight(e, 1, 0.7, 0.3, 0.40)
			PointLight(f, 1, 0.7, 0.3, 0.40)
			PointLight(g, 1, 0.7, 0.3, 0.40)
			PointLight(h, 1, 0.7, 0.3, 0.40)
			PointLight(i, 1, 0.7, 0.3, 0.40)

			-- Compute and make lots of holes
			local r = TransformToParentPoint(t, Vec((math.random(2, 4)*0.1), (math.random(2, 4)*-0.1), (math.random(10, 33)*-0.1)))
			MakeHole(r, math.random(40, 50)*0.01, math.random(25, 30)*0.01, math.random(20, 25)*0.01, "silent")
			local s = TransformToParentPoint(t, Vec((math.random(1, 6)*0.1), (math.random(1, 6)*-0.01), (math.random(34, 66)*-0.1)))
			MakeHole(s, math.random(30, 40)*0.01, math.random(20, 25)*0.01, math.random(15, 20)*0.01, "silent")
			local u = TransformToParentPoint(t, Vec((math.random(1, 9)*0.1)-.5, ((math.random(10, 90)*0.01)-.5), (math.random(67, 100)*-0.1)))
			MakeHole(u, math.random(200, 300)*0.001, math.random(150, 200)*0.001, math.random(100, 150)*0.001, "silent")

			-- Get all physical and dynamic bodies in front of Player
			-- Blast away small bodies in front of Player			
			local mi = VecAdd(c, Vec(-maxDist/5, -maxDist/5, -maxDist/1))
			local ma = VecAdd(c, Vec(maxDist/5, maxDist/5, maxDist/20))
			QueryRequire("physical dynamic")
			local bodies = QueryAabbBodies(mi, ma)

			for i=1,#bodies do
				local b = bodies[i]
				local bmi, bma = GetBodyBounds(b)
				local bc = VecLerp(bmi, bma, 0.5)
				local dir = VecSub(bc, t.pos)
				local dist = VecLength(dir)
				dir = VecScale(dir, 1.0/dist)
				
				local mass = GetBodyMass(b)
				if dist < maxDist and mass < maxMass then
					dir[2] = 0.5
					dir = VecNormalize(dir)

					local massScale = 1 - math.min(mass/maxMass, 1.0)
					local distScale = 1 - math.min(dist/maxDist, 1.0)	
					local add = VecScale(dir, strength * massScale * distScale)

					local vel = GetBodyVelocity(b)
					vel = VecAdd(vel, add)
					SetBodyVelocity(b, vel)
				end
			end
		end

		-- Check if Left Mouse Button is Pressed Down activating Plasma Cutter
		if InputDown("lmb") and not InputDown("rmb") then
			
			-- Get fire spawn locations in front of Player
			local t = GetCameraTransform()		
			local c = TransformToParentPoint(t, Vec(0.3, -0.3, -1))
			local d = TransformToParentPoint(t, Vec(0.3, -0.3, -2.5))	
			local e = TransformToParentPoint(t, Vec(0.2,-0.2, -4))
			local f = TransformToParentPoint(t, Vec(0.2, -0.2, -5.5))	
			local g = TransformToParentPoint(t, Vec(0.1, -0.1, -7))
			local h = TransformToParentPoint(t, Vec(0.1, -0.1, -8.5))	
			local i = TransformToParentPoint(t, Vec(0.1, -0.1, -10))
			
			-- make lots of fire if something combustible is there
			SpawnFire(c) SpawnFire(d) SpawnFire(e)
			SpawnFire(f) SpawnFire(g) SpawnFire(h)
			SpawnFire(i)  
			
			-- Compute and make lots of holes		
			local uuuu = TransformToParentPoint(t, Vec(0.3, -0.3, -2)) 
			MakeHole(uuuu, .2, .2, .2, "silent")
			local v = TransformToParentPoint(t, Vec(0.3, -0.3, -2.3))
			local vv = TransformToParentPoint(t, Vec(0.3, -0.3, -2.6))
			local vvv = TransformToParentPoint(t, Vec(0.3, -0.3, -2.9))
			local vvvv = TransformToParentPoint(t, Vec(0.3, -0.3, -3.2))
			MakeHole(v, .2, .2, .2, "silent") MakeHole(vv, .2, .2, .2, "silent") 
			MakeHole(vvv, .2, .2, .2, "silent") MakeHole(vvvv, .2, .2, .2, "silent")
			local w = TransformToParentPoint(t, Vec(0.2, -0.2, -3.5))
			local ww = TransformToParentPoint(t, Vec(0.2, -0.2, -3.8))
			local www = TransformToParentPoint(t, Vec(0.2, -0.2, -4.1))
			local wwww = TransformToParentPoint(t, Vec(0.2, -0.2, -4.4))
			MakeHole(w, .2, .2, .2, "silent") MakeHole(ww, .2, .2, .2, "silent") 
			MakeHole(www, .2, .2, .2, "silent") MakeHole(wwww, .2, .2, .2, "silent")
			local x = TransformToParentPoint(t, Vec(0.2, -0.2, -4.7))
			local xx = TransformToParentPoint(t, Vec(0.2, -0.2, -5))
			local xxx = TransformToParentPoint(t, Vec(0.2, -0.2, -5.3))
			local xxxx = TransformToParentPoint(t, Vec(0.2, -0.2, -5.6))
			MakeHole(x, .2, .2, .2, "silent") MakeHole(xx, .2, .2, .2, "silent") 
			MakeHole(xxx, .2, .2, .2, "silent") MakeHole(xxxx, .2, .2, .2, "silent")
			local y = TransformToParentPoint(t, Vec(0.2, -0.2, -5.9))
			local yy = TransformToParentPoint(t, Vec(0.2, -0.2, -6.2))
			local yyy = TransformToParentPoint(t, Vec(0.2, -0.2, -6.5))
			local yyyy = TransformToParentPoint(t, Vec(0.1, -0.1, -6.8))
			local yyyyy = TransformToParentPoint(t, Vec(0.1, -0.1, -7.1))
			local yyyyyy = TransformToParentPoint(t, Vec(0.1, -0.1, -7.4))
			local yyyyyyy = TransformToParentPoint(t, Vec(0.1, -0.1, -7.7))
			MakeHole(y, .2, .2, .2, "silent") MakeHole(yy, .2, .2, .2, "silent") 
			MakeHole(yyy, .2, .2, .2, "silent") MakeHole(yyyy, .2, .2, .2, "silent")
			MakeHole(yyyyy, .2, .2, .2, "silent") MakeHole(yyyyyy, .2, .2, .2, "silent")
			MakeHole(yyyyyyy, .2, .2, .2, "silent")
			local z = TransformToParentPoint(t, Vec(0.1, -0.1, -8))
			local zz = TransformToParentPoint(t, Vec(0.1, -0.1, -8.3))
			local zzz = TransformToParentPoint(t, Vec(0.1, -0.1, -8.6))
			local zzzz = TransformToParentPoint(t, Vec(0.1, -0.1, -8.9))
			local zzzzz = TransformToParentPoint(t, Vec(0.1, -0.1, -9.2))
			local zzzzzz = TransformToParentPoint(t, Vec(0.1, -0.1, -9.5))
			local zzzzzzz = TransformToParentPoint(t, Vec(0.1, -0.1, -9.8))
			MakeHole(z, .2, .2, .2, "silent") MakeHole(zz, .2, .2, .15, "silent") 
			MakeHole(zzz, .2, .2, .15, "silent") MakeHole(zzzz, .2, .15, .15, "silent")
			MakeHole(zzzzz, .2, .15, .1, "silent") MakeHole(zzzzzz, .15, .1, .1, "silent")
			MakeHole(zzzzzzz, .1, .1, .1, "silent") 	
		end

		-- Check if Right and Left Mouse Buttons are Pressed Down activating
		-- Incinerator Flames and Plasma Cutter 
		if InputDown("rmb") and InputDown("lmb") then
			
			-- Get fire spawn locations in front of Player
			local t = GetCameraTransform()		
			local c = TransformToParentPoint(t, Vec(0.3, -0.3, -1))
			local d = TransformToParentPoint(t, Vec(0.3, -0.3, -2.5))
			local dd = TransformToParentPoint(t, Vec(0.7, -0.7, -2.8))
			local ddd = TransformToParentPoint(t, Vec(0.7, .1, -3.1))
			local dddd = TransformToParentPoint(t, Vec(-0.1, -0.7, -3.4))
			local ddddd = TransformToParentPoint(t, Vec(-0.1, .1, -3.7))	
			local e = TransformToParentPoint(t, Vec(0.2, -0.2, -4))
			local ee = TransformToParentPoint(t, Vec(0.7, -0.7, -4.3))
			local eee = TransformToParentPoint(t, Vec(0.7, 0.3, -4.6))
			local eeee = TransformToParentPoint(t, Vec(-0.3, -0.7, -4.9))
			local eeeee = TransformToParentPoint(t, Vec(-0.3, 0.3, -5.2))
			local f = TransformToParentPoint(t, Vec(0.2, -0.2, -5.5))
			local ff = TransformToParentPoint(t, Vec(0.8, -0.8, -5.8))
			local fff = TransformToParentPoint(t, Vec(0.8, 0.4, -6.1))
			local ffff = TransformToParentPoint(t, Vec(-0.4, -0.8, -6.4))
			local fffff = TransformToParentPoint(t, Vec(-0.4, 0.4, -6.7))	
			local g = TransformToParentPoint(t, Vec(0.1, -0.1, -7))
			local gg = TransformToParentPoint(t, Vec(0.8, -0.8, -7.3))
			local ggg = TransformToParentPoint(t, Vec(0.8, 0.6, -7.6))
			local gggg = TransformToParentPoint(t, Vec(-0.6, -0.8, -7.9))
			local ggggg = TransformToParentPoint(t, Vec(-0.6, 0.6, -8.2))
			local h = TransformToParentPoint(t, Vec(0.1, -0.1, -8.5))	
			local hh = TransformToParentPoint(t, Vec(0.9, -0.9, -8.8))
			local hhh = TransformToParentPoint(t, Vec(0.9, 0.7, -9.1))
			local hhhh = TransformToParentPoint(t, Vec(-0.7, -0.9, -9.4))	
			local hhhhh = TransformToParentPoint(t, Vec(-0.7, 0.7, -9.7))
			local i = TransformToParentPoint(t, Vec(0.1, -0.1, -10))
			local ii = TransformToParentPoint(t, Vec(0.7, -0.7, -10.5))
			local iii = TransformToParentPoint(t, Vec(0.7, 0.5, -11))	
			local iiii = TransformToParentPoint(t, Vec(-0.5, -0.7, -11.5))
			local j = TransformToParentPoint(t, Vec(-0.5, 0.5, -12))	
			local jj = TransformToParentPoint(t, Vec(0, 0, -12.5))
			local jjj = TransformToParentPoint(t, Vec(0.4, -0.4, -13))
			local jjjj = TransformToParentPoint(t, Vec(0.4, 0.4, -13.5))	
			local k = TransformToParentPoint(t, Vec(-0.4, -0.4, -14))
			local kk = TransformToParentPoint(t, Vec(-0.4, 0.4, -14.5))
			local kkk = TransformToParentPoint(t, Vec(0, 0, -15))	
			local kkkk = TransformToParentPoint(t, Vec(0.3, -0.3, -15.5))
			local kkkkk = TransformToParentPoint(t, Vec(-0.3, 0.3, -16))

			-- make tons of fire if something combustible is there
			SpawnFire(c) SpawnFire(d) SpawnFire(dd)
			SpawnFire(ddd) SpawnFire(dddd) SpawnFire(ddddd)
			SpawnFire(e) SpawnFire(ee) SpawnFire(eee)
			SpawnFire(eeee) SpawnFire(eeeee) SpawnFire(f)
			SpawnFire(ff) SpawnFire(fff) SpawnFire(ffff)
			SpawnFire(fffff) SpawnFire(g) SpawnFire(gg)
			SpawnFire(ggg) SpawnFire(gggg) SpawnFire(ggggg)
			SpawnFire(h) SpawnFire(hh) SpawnFire(hhh)
			SpawnFire(hhhh) SpawnFire(hhhhh) SpawnFire(i)
			SpawnFire(ii) SpawnFire(iii) SpawnFire(iiii)
			SpawnFire(j) SpawnFire(jj) SpawnFire(jjj)
			SpawnFire(jjjj) SpawnFire(k) SpawnFire(kk)
			SpawnFire(kkk) SpawnFire(kkkk) SpawnFire(kkkkk)
			PointLight(c, 1, 0.7, 0.3, 0.4*((power*30)+1))
			PointLight(d, 1, 0.7, 0.3, 0.4*((power*30)+1))
			PointLight(e, 1, 0.7, 0.3, 0.4*((power*30)+1))
			PointLight(f, 1, 0.7, 0.3, 0.4*((power*30)+1))
			PointLight(g, 1, 0.7, 0.3, 0.4*((power*30)+1))	
			PointLight(h, 1, 0.7, 0.3, 0.4*((power*30)+1))
			PointLight(i, 1, 0.7, 0.3, 0.4*((power*30)+1))

			-- Get all physical and dynamic bodies in front of Player
			-- Blast away small bodies in front of Player			
			local mi = VecAdd(c, Vec(-maxDist/5, -maxDist/5, -maxDist*((power*7)+1)))
			local ma = VecAdd(c, Vec(maxDist/5, maxDist/5, maxDist/25))
			QueryRequire("physical dynamic")
			local bodies = QueryAabbBodies(mi, ma)

			for i=1,#bodies do
				local b = bodies[i]
				local bmi, bma = GetBodyBounds(b)
				local bc = VecLerp(bmi, bma, 0.5)
				local dir = VecSub(bc, t.pos)
				local dist = VecLength(dir)
				dir = VecScale(dir, 1.0/dist)
				
				local mass = GetBodyMass(b)
				if dist < maxDist*2 and mass < maxMass*10*((power*16)+1) then
					dir[2] = 0.5
					dir = VecNormalize(dir)

					local massScale = 1 - math.min(mass/maxMass, 1.0)
					local distScale = 1 - math.min(dist/maxDist, 1.0)	
					local add = VecScale(dir, strength * massScale * distScale * (2*((power*16)+1)))

					local vel = GetBodyVelocity(b)
					vel = VecAdd(vel, add)
					SetBodyVelocity(b, vel)
				end
			end
		end
	end	
end

function update(dt)
	if cooldownTimer > 0 then
		cooldownTimer = cooldownTimer - dt
	end

	if GetString("game.player.tool") == "incinerator" and GetBool("game.player.canusetool") then
		--Compute hit points and front direction of Player Weapon in world space
		local t = GetCameraTransform()
		local tb = GetToolBody()
		local tbt = GetBodyTransform(tb)
		local pos = tbt.pos
		local dir = TransformToParentVec(tbt, Vec(-0.02, 0.02, -1))
		local hit, dist, normal, shape = QueryRaycast(pos, dir, 9.8, .15)
		local p = TransformToParentPoint(t, Vec(.35, -.3, -1.55))
		local q = TransformToParentPoint(t, Vec(.35, -.3, -1.30))
		local pp = TransformToParentPoint(t, Vec(.45, -.5, -1.65))
		local qq = TransformToParentPoint(t, Vec(.45, -.5, -4))
		local d = TransformToParentVec(t, Vec(-0.07, .06, -1))

		if hit and InputDown("lmb") then --Plasma Cutter Spark Effects
			local hitpoint = VecAdd(pos, VecScale(dir, dist))
			local vel1 = math.random(10,70)*0.1
			local vel2 = math.random(0,60)*0.1
			local vel3 = math.random(10,30)*0.1
			local vel4 = math.random(0,20)*0.1
			local u = Vec((vel1-4), (vel1 * .5), (vel2-3))
			local v = Vec((vel3-2), (vel3 * .5), (vel4-1))
			local w = Vec((vel2-3), (vel1 * .5), (vel1-4))
			local x = Vec((vel4-1), (vel3 * .5), (vel3-2))
			local life = 0.1 * math.random(3, 5)
			life1 = life * 5
			life2 = life * 4

			ParticleReset()
			ParticleEmissive(1, 0, "easein")
			ParticleGravity(-10)
			ParticleRadius(math.random(1, 2)*.01, 0.0, "smooth") 
			ParticleColor(.7,.7,1, 1,.2,0)
			ParticleTile(4)
			ParticleDrag(0, 0.7)
			ParticleCollide(0, 1, "easeout")
			SpawnParticle(hitpoint, u, life1) -- white/violet to red/orange

			ParticleReset()
			ParticleEmissive(1, 0, "easein")
			ParticleGravity(-5)
			ParticleRadius(math.random(2, 3)*.01, 0.0, "easein")
			ParticleColor(1,.8,0.6, 1,.2,0) 
			ParticleTile(4)
			ParticleDrag(0, 0.7)
			ParticleCollide(0, 1, "easeout")
			SpawnParticle(hitpoint, v, life2) -- white/yellow to red/orange

			ParticleReset()
			ParticleEmissive(1, 0, "easein")
			ParticleGravity(-7.5)
			ParticleRadius(math.random(2, 3)*.01, 0.0, "smooth")
			ParticleColor(.8,.8,1, 1,.5,0)
			ParticleTile(4)
			ParticleDrag(0, 0.7)
			ParticleCollide(0, 1, "easeout")
			SpawnParticle(hitpoint, w, life1*.5) -- white/violet to orange

			ParticleReset()
			ParticleEmissive(1, 0, "easein")
			ParticleGravity(-20)
			ParticleRadius(math.random(1, 2)*.01, 0, "easein")
			ParticleColor(1,.8,0.6, 1,.4,0)
			ParticleTile(4)
			ParticleDrag(0, 0.7)
			ParticleCollide(0, 1, "easeout")
			ParticleSticky(0.3, 1)
			SpawnParticle(hitpoint, x, life2*5) -- white/yellow to orange
			-- Play electrical spark sound
			PlayLoop(snd5, hitpoint, (math.random(7,  10)*0.1))
			PointLight(hitpoint, .8, .8, 1, plasma)
		end
		local hit, dist, normal, shape = QueryRaycast(pos, dir, 16, .15)
		if hit and InputDown("lmb") and InputDown("rmb") then --Combined Plasma Incinerator Spark Effects
			local hitpoint = VecAdd(pos, VecScale(dir, dist))
			local vel1 = math.random(10,70)*0.1
			local vel2 = math.random(0,60)*0.1
			local vel3 = math.random(10,30)*0.1
			local vel4 = math.random(0,20)*0.1
			local u = Vec((vel1-4), (vel1 * .4*((power*50)+1)), (vel2-3))
			local v = Vec((vel3-2), (vel3 * .4*((power*50)+1)), (vel4-1))
			local w = Vec((vel2-3), (vel1 * .4*((power*50)+1)), (vel1-4))
			local x = Vec((vel4-1), (vel3 * .4*((power*50)+1)), (vel3-2))
			local uu = Vec(0, 0.05, 0)
			local vv = Vec(0, 0.1, 0)
			local ww = Vec(0, 0.15, 0)
			local xx = Vec(0, 0.2, 0)
			local uuu = Vec(0, 0.25, 0)
			local vvv = Vec(0, 0.3, 0)
			local www = Vec(0, 0.35, 0)
			local xxx= Vec(0, 0.4, 0)
			local uuuu = Vec((vel3-2)*.1, (vel3 * .1*((power*50)+1)), (vel4-1)*.1)
			local vvvv = Vec((vel3-2)*.2, (vel3 * .15*((power*50)+1)), (vel4-1)*.2)
			local wwww = Vec((vel3-2)*.3, (vel3 * .2*((power*50)+1)), (vel4-1)*.3)
			local xxxx = Vec((vel3-2)*.4, (vel3 * .25*((power*50)+1)), (vel4-1)*.4)
			local uuuuu = Vec((vel3-2)*.5, (vel3 * .3*((power*50)+1)), (vel4-1)*.5)
			local vvvvv = Vec((vel3-2)*.6, (vel3 * .35*((power*50)+1)), (vel4-1)*.6)
			local wwwww = Vec((vel3-2)*.7, (vel3 * .4*((power*50)+1)), (vel4-1)*.7)
			local xxxxx = Vec((vel3-2)*.8, (vel3 * .45*((power*50)+1)), (vel4-1)*.8)
			local life = 0.1 * math.random(3, 5)
			life1 = life * 5
			life2 = life * 4

			ParticleReset()
			ParticleEmissive(1, 0, "easein")
			ParticleGravity(-10)
			ParticleRadius(math.random(1, 2)*.01, 0.0, "smooth") 
			ParticleColor(.75,.75,1, 1,.2,0)
			ParticleTile(4)
			ParticleDrag(0, 0.7)
			ParticleCollide(0, 1, "easeout")
			SpawnParticle(hitpoint, u, life1) -- white/violet to red/orange

			ParticleReset()
			ParticleEmissive(1, 0, "easein")
			ParticleGravity(-5)
			ParticleRadius(math.random(2, 3)*.01, 0.0, "easein")
			ParticleColor(1,.8,0.6, 1,.2,0) 
			ParticleTile(4)
			ParticleDrag(0, 0.7)
			ParticleCollide(0, 1, "easeout")
			SpawnParticle(hitpoint, v, life2) -- white/yellow to red/orange

			ParticleReset()
			ParticleEmissive(1, 0, "easein")
			ParticleGravity(-7.5)
			ParticleRadius(math.random(2, 3)*.01, 0.0, "smooth")
			ParticleColor(.8,.8,1, 1,.5,0)
			ParticleTile(4)
			ParticleDrag(0, 0.7)
			ParticleCollide(0, 1, "easeout")
			SpawnParticle(hitpoint, w, life1*.5) -- white/violet to orange

			ParticleReset()
			ParticleEmissive(1, 0, "easein")
			ParticleGravity(math.random(5, 8)*-1, math.random(8, 10)*-1, "smooth")
			ParticleRadius(math.random(1, 3)*.01*((power*10)+1), 0, "smooth")
			ParticleColor(1,math.random(75, 85)*0.01,math.random(55, 65)*0.01, 1,.4,0, "smooth")          
			ParticleTile(4)
			ParticleCollide(0, 1, "easeout")
			ParticleSticky(1, .3)
			-- power minimum slag
			SpawnParticle(hitpoint, x, life1*4) -- white/yellow to orange
			SpawnParticle(hitpoint, uu, life1*3) -- white/yellow to orange
			SpawnParticle(hitpoint, vv, life1*4) -- white/yellow to orange
			SpawnParticle(hitpoint, ww, life2*3) -- white/yellow to orange
			SpawnParticle(hitpoint, xx, life2*4) -- white/yellow to orange
			-- power normal and maximum slag
			SpawnParticle(hitpoint, uuu, life1*3*((power-.01)*50)) -- white/yellow to orange
			SpawnParticle(hitpoint, vvv, life1*2*((power-.01)*50)) -- white/yellow to orange
			SpawnParticle(hitpoint, www, life2*3*((power-.01)*50)) -- white/yellow to orange
			SpawnParticle(hitpoint, xxx, life2*2*((power-.01)*50)) -- white/yellow to orange
			
			-- power maximum slag	
			SpawnParticle(hitpoint, uuuu, life1*3*((power-.01)*100)-1) -- white/yellow to orange
			SpawnParticle(hitpoint, vvvv, life1*2*((power-.01)*100)-1) -- white/yellow to orange
			SpawnParticle(hitpoint, wwww, life2*3*((power-.01)*100)-1) -- white/yellow to orange
			SpawnParticle(hitpoint, xxxx, life2*2*((power-.01)*100)-1) -- white/yellow to orange
			SpawnParticle(hitpoint, uuuuu, life1*3*((power-.01)*100)-1) -- white/yellow to orange
			SpawnParticle(hitpoint, vvvvv, life1*2*((power-.01)*100)-1) -- white/yellow to orange
			SpawnParticle(hitpoint, wwwww, life2*3*((power-.01)*100)-1) -- white/yellow to orange
			SpawnParticle(hitpoint, xxxxx, life2*2*((power-.01)*100)-1) -- white/yellow to orange
			
			
			-- Play electrical spark sound
			PlayLoop(snd5, hitpoint, (math.random(7, 10)*0.1))
			PointLight(hitpoint, .8, .8, 1, plasma)
		end

		if InputDown("rmb") and not InputDown("lmb") then --Incinerator Flame Effects
			local v = GetPlayerVelocity()
			v = VecAdd(v, VecScale(d, -.1))

			local pvel = VecScale(v, .7)
			ParticleReset()			
			ParticleColor(1,math.random(40, 50)*.01,0, 1,math.random(20, 40)*.01,0) 
			ParticleEmissive(1, 0)
			ParticleCollide(0.01)
			ParticleTile(5)
			ParticleRadius(.06, 2)
			ParticleAlpha(1, 0)
			ParticleGravity(0, 20)
			ParticleDrag(0, .3)
			SpawnParticle(pp, VecAdd(pvel, VecScale(d, 30)), .7) -- medium orange to red
			ParticleColor(1,math.random(75, 85)*.01,.1, 1,math.random(55, 65)*.01,.4)   
			ParticleEmissive(3, 0)
			ParticleCollide(.01)
			ParticleTile(5)
			ParticleRadius(.05, 1.5)
			ParticleAlpha(1, 0)
			ParticleGravity(0, 20)
			ParticleDrag(0, .3)
			SpawnParticle(pp, VecAdd(pvel, VecScale(d, 30)), .7) -- smaller yellow to orange
			ParticleColor(1,1,.8, .8,.8,math.random(50, 60)*.01)  
			ParticleEmissive(5, 0)
			ParticleCollide(0.01)
			ParticleTile(3)
			ParticleRadius(.1, 1.25)
			ParticleAlpha(.5, 0, "easeout")
			ParticleGravity(0, 20)
			ParticleDrag(0, .3)
			SpawnParticle(pp, VecAdd(pvel, VecScale(d, 30)), .7) -- smallest white to white/yellow
			ParticleRadius(.1, 5)
			ParticleColor(0,0,0, .1,.1,.1)
			ParticleTile(14)
			ParticleCollide(0.01)
			ParticleAlpha(.6, 0)
			ParticleGravity(0, 20)
			ParticleDrag(0, .3)
			SpawnParticle(pp, VecAdd(pvel, VecScale(d, 30)), 1.8) -- bigger black
			--Play Incinerator sound
			PlayLoop(snd1, GetPlayerTransform().pos, (math.random(5, 7)*0.1))				
		end	

		if InputDown("lmb") and not InputDown("rmb") then --Plasma Cutter Blast Effects	
			local v = GetPlayerVelocity()
			v = VecAdd(v, VecScale(d, -.1))

			local pvel = VecScale(v, .7)
			ParticleReset()			
			ParticleColor(1,.6,1, .6,1,1)
			ParticleEmissive(1, 0)
			ParticleCollide(0)
			ParticleTile(3)
			ParticleRadius(.08, .03)
			ParticleAlpha(1, 0)
			ParticleStretch(2.5)
			SpawnParticle(p, VecAdd(pvel, VecScale(d, 20)), .2) -- big - violet to lightest blue
			ParticleColor(1,.3,1, .3,1,1)
			ParticleEmissive(3, 0)
			ParticleCollide(0)
			ParticleTile(3)
			ParticleRadius(.06, .02)
			ParticleAlpha(1, 0)
			ParticleStretch(2.5)
			SpawnParticle(q, VecAdd(pvel, VecScale(d, 25)), .2) -- medium - violet to light blue
			ParticleColor(0,1,1, 1,1,1)
			ParticleEmissive(5, 0)
			ParticleCollide(0)
			ParticleTile(3)
			ParticleRadius(.04, .01)
			ParticleAlpha(1, 0)
			ParticleStretch(2.5)
			SpawnParticle(q, VecAdd(pvel, VecScale(d, 30)), .2) -- small - white to blue
			--Play Plasma sound
			PlayLoop(snd2, GetPlayerTransform().pos, 0.3)
		end

		if InputDown("lmb") and InputDown("rmb") then --Plasma Incinerator Combined Effects	
			local v = GetPlayerVelocity()
			v = VecAdd(v, VecScale(d, -.1))

			local pvel = VecScale(v, .7)
			-- fire effect (Thanks Dzage)
			ParticleReset()
			ParticleType("smoke")
			ParticleTile(5)
			ParticleColor(1, 0.6, 0.3, 0, 0, 0)
			ParticleRadius(0.19+(power*3),1.7+(power*150), "easein")
			ParticleAlpha(0.8,0.1)
			ParticleGravity(1)
			ParticleEmissive(1,0.1)
			ParticleCollide(1)
			ParticleDrag(0, .3)
			SpawnParticle(qq,VecAdd(VecAdd(VecScale(d,5),VecScale(d,5)),VecScale(GetPlayerVelocity(),1)),.8)

			ParticleReset()
			ParticleColor(1.0, 0.65, 0.5, 0.85, 0.33, 0.0)
			ParticleRadius(0.19+(power*3),1.7+(power*150), "easein")
			ParticleType("smoke")
			ParticleTile(5)
			ParticleGravity(1)
			ParticleEmissive(3.0, 0.5, "easein")
			ParticleRotation(3, 0, "linear")
			ParticleStretch(8)
			ParticleCollide(1.0)
			ParticleDrag(0, .3)
			SpawnParticle(qq,VecAdd(VecAdd(VecScale(d,5),VecScale(d,5)),VecScale(GetPlayerVelocity(),1)),.8)

			ParticleReset()
			ParticleType("smoke")
			ParticleTile(5)
			ParticleColor(1, 0.3, 0, 0, 0, 0)
			ParticleRadius(0.19+(power*3),1.7+(power*150), "easein")
			ParticleAlpha(0.8,0.1)
			ParticleGravity(1)
			ParticleEmissive(1,0.1)
			ParticleCollide(1)
			ParticleDrag(0, .3)
			SpawnParticle(qq,VecAdd(VecAdd(VecScale(d,5),VecScale(d,5)),VecScale(GetPlayerVelocity(),1)),.8)

			--Plasma Cutter Blast Effects	
			ParticleReset()			
			ParticleColor(1,.6,1, .6,1,1)
			ParticleEmissive(1, 0)
			ParticleCollide(0)
			ParticleTile(3)
			ParticleRadius(.05+(power*3), .03)
			ParticleAlpha(1, 0)
			ParticleStretch(2.5)
			SpawnParticle(p, VecAdd(pvel, VecScale(d, 20)), .2) -- big - violet to lightest blue
			ParticleColor(1,.3,1, .3,1,1)
			ParticleEmissive(3, 0)
			ParticleCollide(0)
			ParticleTile(3)
			ParticleRadius(.03+(power*3), .02)
			ParticleAlpha(1, 0)
			ParticleStretch(2.5)
			SpawnParticle(q, VecAdd(pvel, VecScale(d, 25)), .2) -- medium - violet to light blue
			ParticleColor(0,1,1, 1,1,1)
			ParticleEmissive(5, 0)
			ParticleCollide(0)
			ParticleTile(3)
			ParticleRadius(.01+(power*3), .01)
			ParticleAlpha(1, 0)
			ParticleStretch(2.5)
			SpawnParticle(q, VecAdd(pvel, VecScale(d, 30)), .2) -- small - white to blue

			--Incinerator Flame Effects
			ParticleReset()			
			ParticleColor(1,math.random(40, 50)*.01,0, 1,math.random(20, 40)*.01,0)
			ParticleEmissive(1, 0)
			ParticleCollide(0.01)
			ParticleTile(5)
			ParticleRadius(.03+(power*3), 1.7+(power*10))
			ParticleAlpha(1, 0)
			ParticleGravity(0, 20)
			ParticleDrag(0, .3)
			SpawnParticle(pp, VecAdd(pvel, VecScale(d, 30)), .5) -- medium orange to red
			ParticleColor(1,math.random(75, 85)*.01,.1, 1,math.random(55, 65)*.01,.4)
			ParticleEmissive(3, 0)
			ParticleCollide(.01)
			ParticleTile(5)
			ParticleRadius(.02+(power*3), 1.2+(power*10))
			ParticleAlpha(1, 0)
			ParticleGravity(0, 20)
			ParticleDrag(0, .3)
			SpawnParticle(pp, VecAdd(pvel, VecScale(d, 30)), .5) -- smaller yellow to orange
			ParticleColor(1,1,.8, .8,.8,math.random(50, 60)*.01)
			ParticleEmissive(5, 0)
			ParticleCollide(0.01)
			ParticleTile(3)
			ParticleRadius(.07+(power*3), .95+(power*10))
			ParticleAlpha(.5, 0, "easeout")
			ParticleGravity(0, 20)
			ParticleDrag(0, .3)
			SpawnParticle(pp, VecAdd(pvel, VecScale(d, 30)), .5) -- smallest white to white/yellow			
			--Play Incinerator sound
			PlayLoop(snd1, GetPlayerTransform().pos, 10*(0.07+power))
			PlayLoop(snd2, GetPlayerTransform().pos, (math.random(4, 6)*(0.1+power)))
		end
	end
end

function draw()-- Plasma Incinerator Logo
	if GetString("game.player.tool") == "incinerator" and GetBool("game.player.canusetool") then
		UiPush()
			UiAlign("center")
			UiTextOutline(0,0,0,1,0,0.1)
			UiTranslate(UiCenter()/1,UiHeight()*0.98)
			UiFont("bold.ttf", 30)
			UiColor(1,.1,0)
			UiText("INCINERATOR")
		UiPop()
		UiPush()
			UiAlign("center")
			UiTextOutline(0,0,0,1,0,0.1)
			UiTranslate(UiCenter()/1,UiHeight()*0.9815)
			UiFont("bold.ttf", 29)
			UiColor(1,.4,0)
			UiText("INCINERATOR")
		UiPop()
		UiPush()
			UiAlign("center")
			UiTextOutline(0,0,0,1,0,0.1)
			UiTranslate(UiCenter()/1,UiHeight()*0.983)
			UiFont("bold.ttf", 28)
			UiColor(1,.7,0)
			UiText("INCINERATOR")
		UiPop()
		UiPush()
			UiAlign("center")
			UiTextOutline(0,0,0,1,0,0.1)
			UiTranslate(UiCenter()/1,UiHeight()*0.984)
			UiFont("bold.ttf", 27)
			UiColor(1,1,0)
			UiText("INCINERATOR")
		UiPop()
		UiPush()
			UiAlign("center")
			UiTextOutline(0,0,0,1,0,0.1)
			UiTranslate(UiCenter()/1,UiHeight()*0.9485)
			UiFont("bold.ttf", 31)
			UiColor(1,.75,1)
			UiText("PLASMA")
		UiPop()
		UiPush()
			UiAlign("center")
			UiTextOutline(0,0,0,1,0,0.1)
			UiTranslate(UiCenter()/1,UiHeight()*0.9465)
			UiFont("bold.ttf", 30)
			UiColor(.6,.5,1)
			UiText("PLASMA")
		UiPop()
		UiPush()
			UiAlign("center")
			UiTextOutline(0,0,0,1,0,0.1)
			UiTranslate(UiCenter()/1,UiHeight()*0.9445)
			UiFont("bold.ttf", 29)
			UiColor(.3,.75,1)
			UiText("PLASMA")
		UiPop()
		UiPush()
			UiAlign("center")
			UiTextOutline(0,0,0,1,0,0.1)
			UiTranslate(UiCenter()/1,UiHeight()*0.942)
			UiFont("bold.ttf", 28)
			UiColor(0,1,1)
			UiText("PLASMA")
		UiPop()
		UiPush()
			UiAlign("center")
			UiTextOutline(0,0,0,1,0,0.1)
			UiTranslate(UiCenter()/1,UiHeight()*0.94)
			UiFont("bold.ttf", 26)
			UiColor(1,1,1)
			UiText("PLASMA")
		UiPop()
	end
	if GetString("game.player.tool") == "incinerator" and GetBool("game.player.canusetool") and cooldownTimer <= 0 then
		UiPush()
			UiAlign("center")
			UiTextOutline(0, 0, 0, 1, 0.1)
			UiTranslate(2050, 1050)
			UiFont("bold.ttf", 26)	
			UiColor(.75, .75, .75)
			UiText("Press   H   to Hide Options")
		UiPop()
		UiPush()
			UiAlign("center")
			UiTextOutline(0, 0, 0, 1, 0.1)
			UiTranslate(220, 1020)
			UiFont("bold.ttf", 26)	
			UiColor(.75, .75, .75)
			UiText("Press   P   to Change Plasma Light Intensity")
		UiPop()
		UiPush()
			UiAlign("center")
			UiTextOutline(0, 0, 0, 1, 0.1)
			UiTranslate(220, 1050)
			UiFont("bold.ttf", 26)	
			UiColor(.6, .6, .6)
			UiText("Off     Low     Normal     Medium     High")
		UiPop()
		if plasma == 0 then 
			UiPush()
				UiAlign("center")
				UiTextOutline(0, 0, 0, 1, 0.1)
				UiTranslate(57.5, 1050)
				UiFont("bold.ttf", 26)	
				UiColor(.9, .9, .9)
				UiText("Off")
			UiPop()
		end
		if plasma == .3 then 
			UiPush()
				UiAlign("center")
				UiTextOutline(0, 0, 0, 1, 0.1)
				UiTranslate(115.5, 1050)
				UiFont("bold.ttf", 26)	
				UiColor(.9, .9, .9)
				UiText("Low")
			UiPop()
		end
		if plasma == 1 then 
			UiPush()
				UiAlign("center")
				UiTextOutline(0, 0, 0, 1, 0.1)
				UiTranslate(193.5, 1050)
				UiFont("bold.ttf", 26)	
				UiColor(.9, .9, .9)
				UiText("Normal")
			UiPop()
		end
		if plasma == 3 then 
			UiPush()
				UiAlign("center")
				UiTextOutline(0, 0, 0, 1, 0.1)
				UiTranslate(292.5, 1050)
				UiFont("bold.ttf", 26)	
				UiColor(.9, .9, .9)
				UiText("Medium")
			UiPop()
			UiPush()
				UiAlign("center")
				UiTextOutline(0, 0, 0, 1, 0.1)
				UiTranslate(260, 1075)
				UiFont("bold.ttf", 28)	
				UiColor(1, .8, 0)
				UiText("Warning:  Possible Eye Strain At This Setting")
			UiPop()
		end
		if plasma == 9 then 
			UiPush()
				UiAlign("center")
				UiTextOutline(0, 0, 0, 1, 0.1)
				UiTranslate(377, 1050)
				UiFont("bold.ttf", 26)	
				UiColor(.9, .9, .9)
				UiText("High")
			UiPop()
			UiPush()
				UiAlign("center")
				UiTextOutline(0, 0, 0, 1, 0.1)
				UiTranslate(260, 1075)
				UiFont("bold.ttf", 28)	
				UiColor(1, .1, 0)
				UiText("Warning:  Probable Eye Strain At This Setting")
			UiPop()
		end
		UiPush()
			UiAlign("center")
			UiTextOutline(0, 0, 0, 1, 0.1)
			UiTranslate(820, 1020)
			UiFont("bold.ttf", 26)	
			UiColor(.75, .75, .75)
			UiText("Press   O   to Increase Combined Power Output")
		UiPop()
		UiPush()
			UiAlign("center")
			UiTextOutline(0, 0, 0, 1, 0.1)
			UiTranslate(820, 1050)
			UiFont("bold.ttf", 26)	
			UiColor(.6, .6, .6)
			UiText("Normal     Extra     Maximum")
		UiPop()
		if power == .01 then 
			UiPush()
				UiAlign("center")
				UiTextOutline(0, 0, 0, 1, 0.1)
				UiTranslate(722.5, 1050)
				UiFont("bold.ttf", 26)	
				UiColor(.9, .9, .9)
				UiText("Normal")
			UiPop()
		end
		if power == .02 then 
			UiPush()
				UiAlign("center")
				UiTextOutline(0, 0, 0, 1, 0.1)
				UiTranslate(807, 1050)
				UiFont("bold.ttf", 26)	
				UiColor(.9, .9, .9)
				UiText("Extra")
			UiPop()
		end
		if power == .03 then 
			UiPush()
				UiAlign("center")
				UiTextOutline(0, 0, 0, 1, 0.1)
				UiTranslate(904.5, 1050)
				UiFont("bold.ttf", 26)	
				UiColor(.9, .9, .9)
				UiText("Maximum")
			UiPop()
		end
	end
end

